/*
 * File: Apt.h
 * Created: Fri 07 Mar 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#ifndef _APT_H_
#define _APT_H_

#include <QString>
#include <QRegExp>
#include <QStringList>
#include <QDebug>
#include <QObject>
#include <QFile>
#include <QProcess>
#include <QList>
#include <QByteArray>
#include <QListIterator>
#include <QThread>

#include "MyProcess.h"

class Apt: public QObject
{
    Q_OBJECT
public:
    Apt( QThread *parent = 0 );
    virtual ~Apt();

    int install ( const QStringList &pkgs, bool simulate );
    int addCD ( const QString &mntPoint );
    QStringList getNotInstalled ( QStringList pkgs );
    bool getArePackagesAvailable ( const QStringList &pkgs );
    bool getIsPackageInstalled ( const QString &pkg )
    {
        return getNotInstalled ( QStringList ( pkg ) ).isEmpty();
    }
private slots:
    void debugProcess ( QByteArray ba );
    
private:
    QByteArray dbg;
    MyProcess *m_cdProcess;
    MyProcess *m_installProcess;
    QProcess  *m_readListProcess;
    QProcess  *m_aptCacheProcess;
    bool       m_available;
    QRegExp    m_unavailableRegExp;
};

#endif
