/*
 * File: Firmware.h
 * Created: Apr 2008
 * Last modified: Tue 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#ifndef FIRMWARE_H_
#define FIRMWARE_H_

#include <QProcess>
#include <QString>
#include <QStringList>
#include <QDir>
#include <QFileInfo>
#include <QThread>

class Firmware: public QObject
{
    Q_OBJECT
public:
    Firmware( QThread *parent = 0 );
    virtual ~Firmware();
    
    bool installUeagleFirmware ( const QString &tarArch )
    {
        return installFirmware ( tarArch, "/lib/firmware/ueagle-atm" );
    }
    bool installSpeedtchFirmware ( const QString &tarArch )
    {
        return installFirmware ( tarArch, "/lib/firmware" );
    }
    bool installCxacruFirmware ( const QString &tarArch )
    {
        return installFirmware ( tarArch, "/lib/firmware" );
    }
    
private:
    bool installFirmware ( const QString &tarArch, const QString &destPath );
    QProcess *m_tarProc;
    QDir *m_destDir;
};

#endif /*FIRMWARE_H_*/
