#ifndef GLOBALS_H_
#define GLOBALS_H_

#include <QString>
#include <stdio.h>

extern bool debug;
extern FILE *pFile;

void setDebug( bool debug, const QString fileName = "" );

enum ModemState
{
	Synchronized,
	Synchronizing,
	SynchronizationFailed,
	Booting,
	Error,
	Unknown
};

namespace UbuDSL
{
	typedef struct Stats
	{
		unsigned long rx_bytes;
		unsigned int  rx_errors;

		unsigned long tx_bytes;
		unsigned int  tx_errors;
		
		unsigned int  rx_bps;
		unsigned int  tx_bps;
	};
}

namespace ConnectionState
{
	enum ConnectionState
	{
		Connected,
		Connecting,
		Disconnected
	};
}

#endif /*GLOBALS_H_*/
