/*
 * File: Rpm.h
 * Created: Apr 2008
 * Last modified: Wed 23 Apr 2008
 * Author: Adrian Łubik
 * License: GNU LGPL v3 or newer
 */

#include <QDebug>
#include <QString>
#include <QStringList>
#include <QList>
#include <QListIterator>
#include <QByteArray>
#include <QProcess>
#include <QThread>

#ifndef _RPM_H_
#define _RPM_H_

class Rpm: public QObject
{
    Q_OBJECT
public:
    Rpm( QThread *parent = 0 );
    virtual ~Rpm();

    QStringList getNotInstalled ( QStringList pkgs );
    bool getIsPackageInstalled ( const QString &pkg )
    {
        return getNotInstalled ( QStringList ( pkg ) ).isEmpty();
    }
protected:
    int queryDB();
    QList<QByteArray> installedPkgs;
    QByteArray readOutput;
    QProcess *m_askProcess;
};

#endif
